Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.gradle.api.file
Interface CopySpec

All Superinterfaces:
  CopyProcessingSpec, CopySourceSpec, PatternFilterable

All Known Subinterfaces:
  CopyAction

All Known Implementing Classes:
  Copy

    public interface CopySpec

extends CopySourceSpec, CopyProcessingSpec, PatternFilterable

A set of specifications for copying files. This includes:

- source directories (multiples allowed)
- destination directory
- ANT like include patterns
- ANT like exclude patterns
- File relocating rules
- renaming rules
- content filters

CopySpecs may be nested by passing a closure to one of the from methods. The closure creates a child CopySpec and delegates methods in the closure to the child. Child CopySpecs inherit any values specified in the parent. Only the leaf CopySpecs will be used in any copy operations. This allows constructs like:

     into('webroot')
     exclude('**/.svn/**')
     from('src/main/webapp') {
        include '**/*.jsp'
     }
     from('src/main/js') {
        include '**/*.js'
     }

In this example, the `into` and `exclude` specifications at the root level are inherited by the two child CopySpecs.

See Also:
  `Copy Task`, `Project.copy()`

Method Summary
`CopySpec` | `exclude(java.lang.Iterable<java.lang.String> excludes)` Adds an ANT style exclude pattern.
`CopySpec` | `exclude(java.lang.String... excludes)` Adds an ANT style exclude pattern.
`CopySpec` | `filter(java.lang.Class<java.io.FilterReader> filterType)` Adds a content filter to be used during the copy.
`CopySpec` | `filter(groovy.lang.Closure closure)` Adds a content filter based on the provided closure.
`CopySpec` | `filter(java.util.Map<java.lang.String,java.lang.Object> map, java.lang.Class<java.io.FilterReader> filterType)` Adds a content filter to be used during the copy.
`CopySpec` | `from(java.lang.Object... sourcePaths)` Specifies source files or directories for a copy.
`CopySpec` | `from(java.lang.Object sourcePath, groovy.lang.Closure c)` Specifies the source for a copy and creates a child CopySourceSpec.
`CopySpec` | `include(java.lang.Iterable<java.lang.String> includes)` Adds an ANT style include pattern.
`CopySpec` | `include(java.lang.String... includes)` Adds an ANT style include pattern.
`CopySpec` | `into(java.lang.Object destPath)` Specifies the destination directory for a copy.
`CopySpec` | `remapTarget(groovy.lang.Closure closure)` Maps a source file to a different relative location under the target directory.
`CopySpec` | `rename(java.lang.String sourceRegEx, java.lang.String replaceWith)` Renames files based on a regular expression.
`CopySpec` | `setExcludes(java.lang.Iterable<java.lang.String> excludes)` Set the allowable exclude patterns.
`CopySpec` | `setIncludes(java.lang.Iterable<java.lang.String> includes)` Set the allowable include patterns.

Methods inherited from interface org.gradle.api.tasks.util.PatternFilterable
`getExcludes, getIncludes`

Method Detail

### from

    CopySpec from(java.lang.Object... sourcePaths)

  Specifies source files or directories for a copy. The toString() method of each sourcePath is used to get a path. The paths are evaluated like `Project.file()` . Relative paths will be evaluated relative to the project directory.

  Specified by:
    `from` in interface `CopySourceSpec`
  Parameters:
    `sourcePaths` - Paths to source directories for the copy

### from

    CopySpec from(java.lang.Object sourcePath,
                  groovy.lang.Closure c)

  Specifies the source for a copy and creates a child CopySourceSpec. SourcePath.toString is used as the path. The source is set on the child CopySourceSpec, not on this one. This may be a path to a single file to copy or to a directory. If the path is to a directory, then the contents of the directory will be copied. The paths are evaluated like `Project.file()` .

  Specified by:
    `from` in interface `CopySourceSpec`
  Parameters:
    `sourcePath` - Path to source for the copy
    `c` - closure for configuring the child CopySourceSpec

### setIncludes

    CopySpec setIncludes(java.lang.Iterable<java.lang.String> includes)

  Set the allowable include patterns. Note that unlike `PatternFilterable.include(Iterable)` this replaces any previously defined includes.

  Specified by:
    `setIncludes` in interface `PatternFilterable`
  Parameters:
    `includes` - an Iterable providing new include patterns
  See Also:
    `Pattern Format`

### setExcludes

    CopySpec setExcludes(java.lang.Iterable<java.lang.String> excludes)

  Set the allowable exclude patterns. Note that unlike `PatternFilterable.exclude(Iterable)` this replaces any previously defined excludes.

  Specified by:
    `setExcludes` in interface `PatternFilterable`
  Parameters:
    `excludes` - an Iterable providing new exclude patterns
  See Also:
    `Pattern Format`

### include

    CopySpec include(java.lang.String... includes)

  Adds an ANT style include pattern. This method may be called multiple times to append new patterns and multiple patterns may be specified in a single call. If includes are not provided, then all files beneath the base directory will be included. If includes are provided, then a file must match at least one of the include patterns to be processed.

  Specified by:
    `include` in interface `PatternFilterable`
  Parameters:
    `includes` - a vararg list of include patterns
  See Also:
    `Pattern Format`

### include

    CopySpec include(java.lang.Iterable<java.lang.String> includes)

  Adds an ANT style include pattern. This method may be called multiple times to append new patterns and multiple patterns may be specified in a single call. If includes are not provided, then all files beneath the base directory will be included. If includes are provided, then a file must match at least one of the include patterns to be processed.

  Specified by:
    `include` in interface `PatternFilterable`
  Parameters:
    `includes` - a Iterable providing more include patterns
  See Also:
    `Pattern Format`

### exclude

    CopySpec exclude(java.lang.String... excludes)

  Adds an ANT style exclude pattern. This method may be called multiple times to append new patterns and multiple patterns may be specified in a single call. If excludes are not provided, then no files will be excluded. If excludes are provided, then files must not match any exclude pattern to be processed.

  Specified by:
    `exclude` in interface `PatternFilterable`
  Parameters:
    `excludes` - a vararg list of exclude patterns
  See Also:
    `Pattern Format`

### exclude

    CopySpec exclude(java.lang.Iterable<java.lang.String> excludes)

  Adds an ANT style exclude pattern. This method may be called multiple times to append new patterns and multiple patterns may be specified in a single call. If excludes are not provided, then no files will be excluded. If excludes are provided, then files must not match any exclude pattern to be processed.

  Specified by:
    `exclude` in interface `PatternFilterable`
  Parameters:
    `excludes` - a Iterable providing new exclude patterns
  See Also:
    `Pattern Format`

### into

    CopySpec into(java.lang.Object destPath)

  Specifies the destination directory for a copy. The path is evaluated relative to the project directory.

  Specified by:
    `into` in interface `CopyProcessingSpec`
  Parameters:
    `destPath` - Path to the destination directory for a Copy
  Returns:
    this

### remapTarget

    CopySpec remapTarget(groovy.lang.Closure closure)

  Maps a source file to a different relative location under the target directory. The closure will be called with a single parameter, the File object for the default location of the copy. This File will have the same relative path from the destination directory that the source file has from its source directory. The closure should return a File object with a new target destination.

  Specified by:
    `remapTarget` in interface `CopyProcessingSpec`
  Parameters:
    `closure` - remap closure
  Returns:
    this

### rename

    CopySpec rename(java.lang.String sourceRegEx,
                    java.lang.String replaceWith)

  Renames files based on a regular expression. Uses java.util.regex type of regular expressions. Note that the replace string should use the '$1' syntax to refer to capture groups in the source regular expression. Files that do not match the source regular expression will be copied with the original name.

  Example:

       rename '(.*)_OEM_BLUE_(.*)', '$1$2'

  would map the file 'style_OEM_BLUE_.css' to 'style.css'

  Specified by:
    `rename` in interface `CopyProcessingSpec`
  Parameters:
    `sourceRegEx` - Source regular expression
    `replaceWith` - Replacement string (use $ syntax for capture groups)
  Returns:
    this

### filter

    CopySpec filter(java.util.Map<java.lang.String,java.lang.Object> map,
                    java.lang.Class<java.io.FilterReader> filterType)

  Adds a content filter to be used during the copy. Multiple calls to filter, add additional filters to the filter chain. Each filter should implement java.io.FilterReader. Include org.apache.tools.ant.filters.* for access to all the standard ANT filters.

  Filter parameters may be specified using groovy map syntax.

  Examples:

          filter(HeadFilter, lines:25, skip:2)
          filter(ReplaceTokens, tokens:[copyright:'2009', version:'2.3.1'])

  Specified by:
    `filter` in interface `CopyProcessingSpec`
  Parameters:
    `map` - map of filter parameters
    `filterType` - Class of filter to add
  Returns:
    this

### filter

    CopySpec filter(java.lang.Class<java.io.FilterReader> filterType)

  Adds a content filter to be used during the copy. Multiple calls to filter, add additional filters to the filter chain. Each filter should implement java.io.FilterReader. Include org.apache.tools.ant.filters.* for access to all the standard ANT filters.

  Examples:

          filter(StripJavaComments)
          filter(com.mycompany.project.CustomFilter)

  Specified by:
    `filter` in interface `CopyProcessingSpec`
  Parameters:
    `filterType` - Class of filter to add
  Returns:
    this

### filter

    CopySpec filter(groovy.lang.Closure closure)

  Adds a content filter based on the provided closure. The Closure will be called with each line (stripped of line endings) and should return a String to replace the line.

  Specified by:
    `filter` in interface `CopyProcessingSpec`
  Parameters:
    `closure` - to implement line based filtering
  Returns:
    this

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD